{ ---------------------------------------------------
 |                                                   |
 |  >>> The(c)King1980 <<<                           |
 |                                                   |
 |  E-Mail   : TheKing1980@hotmail.com               |
 |  Internet : http://www.geocities.com/Eureka/2675  |
 |                                                   |
  --------------------------------------------------- }
{$M 16384,128000,128000}
uses Crt;

type
  Buf = array [1..64000] of byte;

var
  s : string;
  i : integer;
  fin, fout : file;
  tin, tout : text;
  iBuf, oBuf : ^Buf;
  q, q2 : word;
  nr, nw : word;
  p : pointer;
  ch1, ch2 : char;

procedure Help;
begin
  WriteLn('Usage: DM <param> <infile> <outfile>');
  WriteLn;
  WriteLn('Available params:');
  WriteLn('  D2U                   Dos to Unix - This converts Dos',char(39),'s EOL (end of line)');
  WriteLn('                        characters (0x0D, 0x0A) into Unix-like EOL (0x0A)');
  WriteLn('  U2D                   Unix to Dos EOL convertor');
  WriteLn('  WORDS                 Replaces all spaces (0x20) found in input file with EOL');
  WriteLn('                        (i.e.: makes a dictionary) <- USES UNIX-LIKE EOL !!!');
  WriteLn('  REM                   Removes some characters ( . , " : ; - = * ',char(39),' ! ? )');
  Write('  UP                    Converts all letters into uppercase (e.g. a -> A, b -> B');
  Write('  LOW                   Converts all letters into lowercase (e.g. A -> a, B -> b');
  WriteLn('  EXCHANGE              Exchange some letters with another (e.g. z <-> y)');
  WriteLn('                        - you will be asked for these letters');
{  WriteLn('  CLEAN                 Removes all duplicate words in input file');
  WriteLn('  SORT                  Sorts words');}
end;

procedure ERROR(s : string);
begin
  WriteLn;
  WriteLn(s);
  WriteLn;
  Release(p);
  Halt(2);
end;

procedure OpenF;
begin
  {$I-}
  Assign(fin, ParamStr(2));
  Reset(fin,1);
  {$I+}
  if IOResult <> 0 then ERROR('Cannot open input file '+ParamStr(2));
  {$I-}
  Assign(fout, ParamStr(3));
  ReWrite(fout,1);
  {$I+}
  if IOResult <> 0 then ERROR('Cannot create output file '+ParamStr(3));
end;

procedure CloseF;
begin
  Close(fin);
  Close(fout);
end;

procedure OpenT;
begin
  {$I-}
  Assign(tin, ParamStr(2));
  Reset(tin);
  {$I+}
  if IOResult <> 0 then ERROR('Cannot open input file '+ParamStr(2));
  {$I-}
  Assign(tout, ParamStr(3));
  ReWrite(tout);
  {$I+}
  if IOResult <> 0 then ERROR('Cannot create output file '+ParamStr(3));
end;

procedure CloseT;
begin
  Close(tin);
  Close(tout);
end;

procedure D2U;
begin
  OpenF;
  repeat
    BlockRead(fin, iBuf^, SizeOf(iBuf), nr);
    nw:=nr;
    q2:=1;
    for q:=1 to nr do
    begin
      if iBuf^[q]=$0D then
      begin
        Dec(q2);
        Dec(nw);
      end
      else oBuf^[q2]:=iBuf^[q];
      Inc(q2);
    end;
    nr:=nw;
    BlockWrite(fout, oBuf^, nr, nw);
  until (nr = 0) or (nw <> nr);
  CloseF;
end;

procedure U2D;
begin
  OpenF;
  repeat
    BlockRead(fin, iBuf^, (SizeOf(iBuf^) div 2)-2, nr);
    nw:=nr;
    q2:=1;
    for q:=1 to nr do
    begin
      if iBuf^[q]=$0A then
      begin
        oBuf^[q2+1]:=iBuf^[q];
        oBuf^[q2]:=$0D;
        Inc(nw);
        Inc(q2);
      end
      else oBuf^[q2]:=iBuf^[q];
      Inc(q2);
    end;
    nr:=nw;
    BlockWrite(fout, oBuf^, nr, nw);
  until (nr = 0) or (nw <> nr);
  CloseF;
end;

procedure WORDS;
begin
  OpenF;
  repeat
    BlockRead(fin, iBuf^, SizeOf(iBuf), nr);
    for q:=1 to nr do
    begin
      if iBuf^[q]=$20 then oBuf^[q]:=$0A
        else if iBuf^[q]=$0D then oBuf^[q]:=$0A
          else oBuf^[q]:=iBuf^[q];
    end;
    BlockWrite(fout, oBuf^, nr, nw);
  until (nr = 0) or (nw <> nr);
  CloseF;
end;

procedure REM;
begin
  OpenF;
  repeat
    BlockRead(fin, iBuf^, SizeOf(iBuf), nr);
    nw:=nr;
    q2:=1;
    for q:=1 to nr do
    begin
      if iBuf^[q] in [Ord('('),Ord('.'),Ord(','),Ord('"'),Ord(':'),Ord(';'),Ord('-'),Ord('='),
                      Ord('*'),39,Ord('!'),Ord('?'),Ord(')')] then
      begin
        oBuf^[q2]:=iBuf^[q+1];
        Dec(nw);
        Dec(q2);
      end
      else oBuf^[q2]:=iBuf^[q];
      inc(q2);
    end;
    nr:=nw;
    BlockWrite(fout, oBuf^, nr, nw);
  until (nr = 0) or (nw <> nr);
  CloseF;
end;

procedure UP;
begin
  OpenF;
  repeat
    BlockRead(fin, iBuf^, SizeOf(iBuf), nr);
    for q:=1 to nr do
    begin
      if char(iBuf^[q]) in ['a'..'z'] then oBuf^[q]:=iBuf^[q]-32
        else oBuf^[q]:=iBuf^[q];
    end;
    BlockWrite(fout, oBuf^, nr, nw);
  until (nr = 0) or (nw <> nr);
  CloseF;
end;

procedure LOW;
begin
  OpenF;
  repeat
    BlockRead(fin, iBuf^, SizeOf(iBuf), nr);
    for q:=1 to nr do
    begin
      if char(iBuf^[q]) in ['A'..'Z'] then oBuf^[q]:=iBuf^[q]+32
        else oBuf^[q]:=iBuf^[q];
    end;
    BlockWrite(fout, oBuf^, nr, nw);
  until (nr = 0) or (nw <> nr);
  CloseF;
end;

procedure EXCHANGE;
begin
  WriteLn;
  Write('letter #1 :'); ReadLn(ch1);
  Write('letter #2 :'); ReadLn(ch2);
  WriteLn;
  WriteLn('exchanging ',ch1,' <-> ',ch2);
  OpenF;
  repeat
    BlockRead(fin, iBuf^, SizeOf(iBuf), nr);
    for q:=1 to nr do
    begin
      oBuf^[q]:=iBuf^[q];
      if iBuf^[q] = ord(ch1) then oBuf^[q] := ord(ch2)
        else if iBuf^[q] = ord(ch2) then oBuf^[q] := ord(ch1);
    end;
    BlockWrite(fout, oBuf^, nr, nw);
  until (nr = 0) or (nw <> nr);
  CloseF;
end;

{procedure CLEAN;
begin
  OpenT;
  ReadLn(tin, s);
  WriteLn(tout, s);
  repeat
    ReadLn(tin, s);

    WriteLn(tout, s);
  until Eof(tin);
  CloseT;
end;

procedure SORT;
begin
  OpenT;
  CloseT;
end;}

begin
  Mark(p);
  GetMem(iBuf, SizeOf(Buf));
  GetMem(oBuf, SizeOf(Buf));
  WriteLn('DM - Dictionary Manager v1.0                                     TheKing(c)1980');
  Write('                                                                >>> FREEWARE <<<');
  i:=ParamCount;
  s:=ParamStr(1);
  if (i <> 3) OR (s = '/?') OR (s = '-h') OR (s = '-?') OR (s = '/h')
    OR (s = '--help') then Help
    else begin
           if (s = 'D2U') OR (s = 'd2u') then D2U
             else if (s = 'U2D') OR (s = 'u2d') then U2D
               else if (s = 'WORDS') OR (s = 'words') then WORDS
                 else if (s = 'REM') OR (s = 'rem') then REM
                   else if (s = 'UP') OR (s = 'up') then UP
                     else if (s = 'LOW') OR (s = 'low') then LOW
                       else if (s  = 'EXCHANGE') OR (s = 'exchange') then EXCHANGE;
{                         else if (s = 'CLEAN') OR (s = 'clean') then CLEAN
                           else if (s = 'SORT') OR (s = 'sort') then SORT;}
         end;
  Release(p);
end.
